package j3d_lib;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: Borland Software Corporation</p>
 * 3D Engine Programmer - Zabolotnov Vadim Alexandrovich aka Nick-85
 * System Programmer - ? aka Grafmoto
 * Main Tester - ? aka Hobbit19
 * @version 1.0
 */

public class Vector3D {

  // Fields
  public int x; // The x component -   ( abscissa  )
  public int y; // The y component -   ( ordinate  )
  public int z; // The z component -  ( applicate )

  // Constructors
  public Vector3D()  { x=y=z=0; }
  public Vector3D( int x, int y, int z )  { this.x = x; this.y = y; this.z = z; }

  // Methods
  public int getX() { return x; }
  public int getY() { return y; }
  public int getZ() { return z; }
  public void setX( int x ) { this.x = x; }
  public void setY( int y ) { this.y = y; }
  public void setZ( int z ) { this.z = z; }
  public void set ( int x, int y, int z )  { this.x = x; this.y = y; this.z = z; }
  public void unit() // Performs normalization -    (      )
  {
    int dot = x*x + y*y + z*z; //  dot    (  ) 
    if( 0 == dot ) return;
    if ( ( dot > 32768 ) || ( dot < 0 ) ){
      dot >>>= 8; //  dot    (  )   2^8 ( >>> 8 )
      dot = com.motorola.graphics.j3d.Util3D.sqrt( dot ); //  dot   (  )    2^4
      //     fixed point 0:12 signed
      x = ( ( x << 16 ) / dot ) >> 8;
      y = ( ( y << 16 ) / dot ) >> 8;
      z = ( ( z << 16 ) / dot ) >> 8;
      x*2^16 / dot*2^(-4)
      x*2^16 / dot*2
    }
    else{
      dot <<= 8; //  dot    (  )    2^8 ( << 8 )
      dot = com.motorola.graphics.j3d.Util3D.sqrt( dot ); //  dot   (  )    2^4
      //     fixed point 0:12 signed
      x = ( x << 16 ) / dot;
      y = ( y << 16 ) / dot;
      z = ( z << 16 ) / dot;
    }
  }

  public int innerProduct( Vector3D v )  //    
  {
      int dot = x*v.x + y*v.y + z*v.z;
      return dot;
  }

  public void outerProduct( Vector3D v ) //    
  {
    int xr, yr;
    xr =   y * v.z - v.y *   z;
    yr = v.x *   z -   x * v.z;
    z  =   x * v.y - v.x *   y;
    x = xr;    y = yr;
  }

  public static int innerProduct( Vector3D v0, Vector3D v1 )
  {
    int dot = v0.x*v1.x + v0.y*v1.y + v0.z*v1.z;
    return dot;
  }

  public static Vector3D outerProduct( Vector3D v0, Vector3D v1 )
  {
    Vector3D v = new Vector3D();
    v.x = v0.y * v1.z - v1.y * v0.z;
    v.y = v1.x * v0.z - v0.x * v1.z;
    v.z = v0.x * v1.y - v1.x * v0.y;
    return v;
  }
}